unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, MMSystem, Buttons;

type
  TForm1 = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

//=== Funo chamada caso ocorra um erro de MCI ================================
procedure MCIErro(ErrorCode: dWord);
var
  S: string;
begin
  SetLength(S, 128);
  MCIGetErrorString(ErrorCode, PChar(S), 127);
  S:= trim(S);
  raise Exception.Create(S);
end;


//=== Carrega um som do "arquivo" com o "alias" escolhido ======================
procedure MCICarregarWave(Arquivo, Alias: string);
var
  S: string;
  Erro: dword;
begin
  S:= 'open '+ Arquivo + ' type waveaudio alias ' + Alias;
  Erro:= MCISendString(PChar(S), nil, 0, 0);
  if Erro <> 0 then MCIErro(Erro);
end;


//=== Toca um som previamente carregado com o "alias" ==========================
procedure MCITocarAlias(Alias: string);
var
  Erro: dWord;
  S: string;
begin
  S:= 'play ' + Alias + ' from 0';
  Erro:= MCISendString(PChar(S), nil, 0, 0);
  if Erro <> 0 then MCIErro(Erro);
end;


//== Para de tocar um som com o "alias" ========================================
procedure MCIPararAlias(Alias: string);
var
  Erro: dWord;
  S: string;
begin
  S:= 'stop ' + Alias;
  Erro:= MCISendString(PChar(S), nil, 0, 0);
  if Erro <> 0 then MCIErro(Erro);
  S:= 'seek ' + Alias + ' to start';
  Erro:= MCISendString(PChar(S), nil, 0, 0);
  if Erro <> 0 then MCIErro(Erro);
end;


//=== Retorna true se o alias ainda est tocando ===============================
function MCITocando(Alias: string): boolean;
var
  Erro: dWord;
  S, Res: string;
  Len, Pos: integer;
begin
  S:= 'status ' + Alias + ' length';
  SetLength(Res, 21);
  Erro:= MCISendString(PChar(S), PChar(Res), 20, 0);
  if Erro <> 0 then MCIErro(Erro);
  Len:= StrToInt(trim(Res));
  S:= 'status ' + Alias + ' position';
  SetLength(Res, 21);
  Erro:= MCISendString(PChar(S), PChar(Res), 20, 0);
  if Erro <> 0 then MCIErro(Erro);
  Pos:= StrToInt(trim(Res));
  result:= ((Len - Pos) > 0) and (pos > 0);
end;


//=== Fecha o "alias" especificado =============================================
procedure MCIFecharAlias(Alias: string);
var
  Erro: dWord;
  S: string;
begin
  S:= 'close ' + Alias;
  Erro:= MCISendString(PChar(S), nil, 0, 0);
  if Erro <> 0 then MCIErro(Erro);
end;


////////////////////////////////////////////////////////////////////////////////


procedure TForm1.FormCreate(Sender: TObject);
begin
  MCICarregarWave('som1.wav', 'som1');
  MCICarregarWave('som2.wav', 'som2');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MCIFecharAlias('som1');
  MCIFecharAlias('som2');
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  MCITocarAlias('som1');
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  MCITocarAlias('som2');
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  MCIPararAlias('som1');
  MCIPararAlias('som2');
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if MCITocando('som1') then Form1.Caption:= 'tocando'
  else Form1.Caption:= 'no est tocando';
end;

end.

